/**********************************************************************/
/*                                                                    */
/* Copyright (c) 2002 by Sun Microsystems, Inc.                       */
/* All rights reserved.                                               */
/*                                                                    */
/**********************************************************************/

package managed;

import com.sun.emp.cci.eci.ECIInteractionSpec;
import com.sun.emp.cci.eci.GenericRecord;
import com.sun.emp.cci.eci.ECITransactionAbendException;

import java.rmi.RemoteException;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.resource.ResourceException;

import javax.resource.cci.Connection;
import javax.resource.cci.ConnectionFactory;
import javax.resource.cci.Interaction;
import javax.resource.cci.InteractionSpec;

public class MS1Bean implements SessionBean {

    private ConnectionFactory cf;

    public String func1() {
	System.out.println("MS1Bean.func1()");
	String s = null;

	Interaction ia = null;
	Connection c = null;

	try {

	    //
	    // Obtain a connection
	    //
	    c = cf.getConnection();
	    System.out.println("MS1Bean.func1() connection is : " + c);

	    //
	    // Set up to perform an ECI call to get the time
	    //
	    ia = c.createInteraction();
	    ECIInteractionSpec ris = new ECIInteractionSpec();
	    ris.setInteractionVerb(InteractionSpec.SYNC_SEND_RECEIVE);
	    ris.setFunctionName("ECIEX1S ");
	    ris.setCommareaLength(8);

	    GenericRecord rr = new GenericRecord("ASKTIME:".getBytes());

	    //
	    // Make the ECI call
	    //
	    ia.execute(ris,rr,rr);
	    s = rr.toString();
	    System.out.println("MS1Bean: ECI call returned <" + s + ">");

	} catch (ECITransactionAbendException etae) {
	    System.out.println("MS1Bean.func1() ECITransactionAbendException" +
									etae);
	    System.out.println("MS1Bean.func1() " + etae);
	    System.out.println("MS1Bean.func1()   abendCode : " +
							etae.getAbendCode());
	    System.out.println("MS1Bean.func1()   errorCode : " +
							etae.getErrorCode());
	} catch (ResourceException re) {
	    System.out.println("MS1Bean.func1() ResourceException " + re);
	    System.out.println("MS1Bean.func1()   errorCode : " +
							re.getErrorCode());
	} finally {
	    if (c != null) {
		try {
		    c.close();
		} catch (ResourceException re) {
		}
	    } 
	}

	//
	// Return the String containing the time to the callling client
	//
        return s;
    }

    public MS1Bean() {
	System.out.println("MS1Bean()");
    }

    public void ejbCreate() {
	System.out.println("MS1Bean.ejbCreate()");
    }
    public void ejbRemove() {
	System.out.println("MS1Bean.ejbRemove()");
    }
    public void ejbActivate() {
	System.out.println("MS1Bean.ejbActivate()");
    }
    public void ejbPassivate() {
	System.out.println("MS1Bean.ejbPassivate()");
    }
    public void setSessionContext(SessionContext sc) {
	System.out.println("MS1Bean.setSessionContext()");

	try {
	    Context ic = new InitialContext();
	    cf = (ConnectionFactory)ic.lookup("java:comp/env/mtpregion");

	    System.out.println("MS1Bean: cf is " + cf);
        } catch (NamingException ne) {
            ne.printStackTrace();
        }


    }


}
