/**********************************************************************/
/*                                                                    */
/* Copyright (c) 2002 by Sun Microsystems, Inc.                       */
/* All rights reserved.                                               */
/*                                                                    */
/**********************************************************************/

package managed;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class MS1Client {

    public static void main(String[] args) {
	try {
	    Context initial = new InitialContext();
	    Context myEnv = (Context)initial.lookup("java:comp/env");
	    Object objref = myEnv.lookup("ms1");

	    System.out.println("MS1Client: lookup got " + objref);

	    MS1Home home =
		(MS1Home)PortableRemoteObject.narrow(objref,MS1Home.class);

	    MS1Remote rr= home.create();


	    for (int i = 0; i < 5; i++) {
		System.out.println( i + " : " + rr.func1());
	    }

	    System.exit(0);

	} catch (Exception ex) {
	    System.err.println("Caught an unexpected exception!");
	    ex.printStackTrace();
	}
    }
}

